# This makes a sorted box string for you where the boxes are double quoted and
# separated by commas. There will be no duplicate boxes in the sorted string.
#
# What you need to do:
#
# Copy your code that you want to extract the boxes from to the clipboard.
# 
# Press F5 from SciTe while in this code file.
#
# What Happens After You Press F5:
#
# The sorted box string is copied to the clipboard and is also printed to the
# output pane.
#
# Example Output: "box2_20", "box2_23", "box2_25"
# 
# That's it! See ya! Maybe in the near future there will be a Javascript version for
# this and perhaps integration into a tool. Nod nod, wink wink.
#
require 'tk'

codeStr = TkClipboard.get(nil)

rawBoxArray = Array.new
boxPartsArray = Array.new
boxStr = ""

rawBoxArray = codeStr.scan(/box\d+_\d+/).uniq

#print rawBoxArray.length

rawBoxArray.each do |box|

	if (box =~ /box(\d+)_(\d+)/)
		boxPartsArray.push([$1.to_i,$2.to_i])
	end
end

#print boxPartsArray

#
# Now sort the list and convert back to regular box representation [i.e. "box2_5"]
#
boxPartsArray.sort!

boxPartsArray.each_index { |index|
	boxStr += "\"box#{boxPartsArray[index][0]}_#{boxPartsArray[index][1]}\", "
}

boxStr = boxStr.strip.chomp(",")

#
# TkClipboard.set first clears the clipboard.
#
TkClipboard.set(boxStr.empty? ? '' : boxStr, nil)

print boxStr
